# This file was generated by liblab | https://liblab.com/

from enum import Enum

from .utils.base_model import BaseModel
from .utils.json_map import JsonMap


class LangCode(Enum):
    """An enumeration representing different categories.

    :cvar EN: "en"
    :vartype EN: str
    :cvar ES: "es"
    :vartype ES: str
    :cvar IT: "it"
    :vartype IT: str
    :cvar PT: "pt"
    :vartype PT: str
    :cvar DE: "de"
    :vartype DE: str
    :cvar FR: "fr"
    :vartype FR: str
    :cvar KO: "ko"
    :vartype KO: str
    :cvar NL: "nl"
    :vartype NL: str
    :cvar TH: "th"
    :vartype TH: str
    :cvar RU: "ru"
    :vartype RU: str
    :cvar PL: "pl"
    :vartype PL: str
    :cvar JA: "ja"
    :vartype JA: str
    :cvar SV: "sv"
    :vartype SV: str
    :cvar TR: "tr"
    :vartype TR: str
    :cvar CA: "ca"
    :vartype CA: str
    :cvar ID: "id"
    :vartype ID: str
    :cvar UK: "uk"
    :vartype UK: str
    :cvar MS: "ms"
    :vartype MS: str
    :cvar ZH: "zh"
    :vartype ZH: str
    :cvar FI: "fi"
    :vartype FI: str
    :cvar NO: "no"
    :vartype NO: str
    :cvar RO: "ro"
    :vartype RO: str
    """

    EN = "en"
    ES = "es"
    IT = "it"
    PT = "pt"
    DE = "de"
    FR = "fr"
    KO = "ko"
    NL = "nl"
    TH = "th"
    RU = "ru"
    PL = "pl"
    JA = "ja"
    SV = "sv"
    TR = "tr"
    CA = "ca"
    ID = "id"
    UK = "uk"
    MS = "ms"
    ZH = "zh"
    FI = "fi"
    NO = "no"
    RO = "ro"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, LangCode._member_map_.values()))


@JsonMap({})
class AutoCaption(BaseModel):
    """AutoCaption

    :param lang_code: Language of the text track.
    :type lang_code: LangCode
    :param title: Name of the caption., defaults to None
    :type title: str, optional
    """

    def __init__(self, lang_code: LangCode, title: str = None):
        """AutoCaption

        :param lang_code: Language of the text track.
        :type lang_code: LangCode
        :param title: Name of the caption., defaults to None
        :type title: str, optional
        """
        self.lang_code = self._enum_matching(lang_code, LangCode.list(), "lang_code")
        if title is not None:
            self.title = title
