# This file was generated by liblab | https://liblab.com/

from enum import Enum

from .utils.base_model import BaseModel
from .utils.json_map import JsonMap


class TextTrackStatus(Enum):
    """An enumeration representing different categories.

    :cvar READY: "ready"
    :vartype READY: str
    :cvar PROCESSING: "processing"
    :vartype PROCESSING: str
    """

    READY = "ready"
    PROCESSING = "processing"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, TextTrackStatus._member_map_.values()))


class TextTrackType(Enum):
    """An enumeration representing different categories.

    :cvar CAPTION: "caption"
    :vartype CAPTION: str
    :cvar CHAPTER: "chapter"
    :vartype CHAPTER: str
    :cvar EMBEDDEDSUBTITLE: "embedded_subtitle"
    :vartype EMBEDDEDSUBTITLE: str
    :cvar AUTO: "auto"
    :vartype AUTO: str
    """

    CAPTION = "caption"
    CHAPTER = "chapter"
    EMBEDDEDSUBTITLE = "embedded_subtitle"
    AUTO = "auto"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, TextTrackType._member_map_.values()))


@JsonMap({"id_": "id", "type_": "type"})
class TextTrack(BaseModel):
    """TextTrack

    :param cdn_link: Link to the file served by CDN. URL expires after 24 hours by default.
    :type cdn_link: str
    :param default: If the text track is the default one pre-selected.
    :type default: bool
    :param id_: id of the text track.
    :type id_: int
    :param language: Language of the text track.
    :type language: str
    :param status: The status of the text track.
    :type status: TextTrackStatus
    :param title: Title of the text track.
    :type title: str
    :param type_: The type of the text track.
    :type type_: TextTrackType
    """

    def __init__(
        self,
        cdn_link: str,
        default: bool,
        id_: int,
        language: str,
        status: TextTrackStatus,
        title: str,
        type_: TextTrackType,
    ):
        """TextTrack

        :param cdn_link: Link to the file served by CDN. URL expires after 24 hours by default.
        :type cdn_link: str
        :param default: If the text track is the default one pre-selected.
        :type default: bool
        :param id_: id of the text track.
        :type id_: int
        :param language: Language of the text track.
        :type language: str
        :param status: The status of the text track.
        :type status: TextTrackStatus
        :param title: Title of the text track.
        :type title: str
        :param type_: The type of the text track.
        :type type_: TextTrackType
        """
        self.cdn_link = cdn_link
        self.default = default
        self.id_ = id_
        self.language = language
        self.status = self._enum_matching(status, TextTrackStatus.list(), "status")
        self.title = title
        self.type_ = self._enum_matching(type_, TextTrackType.list(), "type_")
